let fsm = "";
//#ifdef MP-WEIXIN
fsm = wx.getFileSystemManager();
//#endif
//#ifdef MP-ALIPAY
fsm = my.getFileSystemManager();
console.error(fsm)
//#endif
//#ifdef MP-TOUTIAO
fsm = tt.getFileSystemManager();
//#endif
const FILE_BASE_NAME = 'tmp_base64src'; //自定义文件名
import { weBtoa, weAtob } from './weapp-jwt.js'
function _base64ToArrayBuffer(base64) {
  var binary_string = weAtob(base64);
  var len = binary_string.length;
  var bytes = new Uint8Array(len);
  for (var i = 0; i < len; i++) {
    bytes[i] = binary_string.charCodeAt(i);
  }
  return bytes.buffer;
}
function base64src(base64data, cb) {
	let fileName = FILE_BASE_NAME + new Date().getTime();
  base64data = base64data.replace(/[\r\n]/g, '');
  let filePath="";

  //#ifdef MP-WEIXIN
  filePath = `${wx.env.USER_DATA_PATH}/${fileName}`;
  //#endif
  //#ifdef MP-ALIPAY
  filePath = `${my.env.USER_DATA_PATH}/${fileName}`;
  //#endif
  //#ifdef MP-TOUTIAO
  filePath = `${tt.env.USER_DATA_PATH}/${fileName}`;
  //#endif
  fsm.unlink({
    filePath: filePath,
    fail: res => {
      console.error(res);
    },
    success(res){
      console.error(res)
    },
    complete: res => {
      let buffer="";
      //#ifdef MP-WEIXIN
       buffer = wx.base64ToArrayBuffer(base64data);
      //#endif
      //#ifdef MP-TOUTIAO
       buffer = tt.base64ToArrayBuffer(base64data);
      //#endif
      //#ifdef MP-ALIPAY
        buffer = _base64ToArrayBuffer(base64data);
        console.error(buffer)
      //#endif
      console.error(buffer)

      fsm.writeFile({
        filePath: filePath,
        data: buffer,
        encoding: 'base64',
        success: res => {
          cb(filePath);
        },
        fail: res => {
          return new Error('ERROR_BASE64SRC_WRITE');
        }
      });
    }
  });
}
export { base64src };
